package graphs;

import java.lang.Comparable;
import java.util.HashMap;
import java.util.PriorityQueue;

public class Dijkstras {
    public static HashMap<Vertex, PathVertexInfo> dijkstraShortestPath(Graph graph, Vertex startVertex) {
        // Create the HashMap for vertex information

        // Put all graph vertices in both the info HashMap and the PriorityQueue
        // of unvisited vertices

        // startVertex has a distance of 0 from itself

        // Iterate through all vertices in the priority queue
            // Get info about the vertex with the shortest distance from startVertex

            // Check potential path lengths from the current vertex to all neighbors


                // If a shorter path from startVertex to adjacentVertex is found,
                // update adjacentVertex's distance and predecessor


        return null;
    }

    public static String getShortestPath(Vertex startVertex, Vertex endVertex,
                                         HashMap<Vertex, PathVertexInfo> infoMap) {
        return null;
    }

    public static void main(String[] args) {
        Graph g = new Graph();

        Vertex vertexA = g.addVertex("A");
        Vertex vertexB = g.addVertex("B");
        Vertex vertexC = g.addVertex("C");
        Vertex vertexD = g.addVertex("D");
        Vertex vertexE = g.addVertex("E");
        Vertex vertexF = g.addVertex("F");
        Vertex vertexG = g.addVertex("G");
        Vertex[] vertices = { vertexA, vertexB, vertexC, vertexD, vertexE, vertexF, vertexG };

        g.addUndirectedEdge(vertexA, vertexB, 8);
        g.addUndirectedEdge(vertexA, vertexC, 7);
        g.addUndirectedEdge(vertexA, vertexD, 3);
        g.addUndirectedEdge(vertexB, vertexE, 6);
        g.addUndirectedEdge(vertexC, vertexD, 1);
        g.addUndirectedEdge(vertexC, vertexE, 2);
        g.addUndirectedEdge(vertexD, vertexF, 15);
        g.addUndirectedEdge(vertexD, vertexG, 12);
        g.addUndirectedEdge(vertexE, vertexF, 4);
        g.addUndirectedEdge(vertexF, vertexG, 1);

        // Run Dijkstra's algorithm first.
        HashMap<Vertex, PathVertexInfo> infoMap = dijkstraShortestPath(g, vertexA);

        // Display shortest path for each vertex from vertexA.
        for (Vertex vertex : vertices) {
            PathVertexInfo info = infoMap.get(vertex);
            if (info.predecessor == null && vertex != vertexA) {
                System.out.printf("A to %s: no path exists%n", vertex.label);
            }
            else {
                System.out.printf("A to %s: %s (total weight: %d)%n", vertex.label,
                        getShortestPath(vertexA, vertex, infoMap), (int)info.distance);
            }
        }
    }
}

